(** * Discrete ordTypes *)
Require Import base protype ordtype.

Section DiscreteOrder.
  Variable A : Type.
  Definition discrete := A.
  Implicit Types (x y z : discrete).

  Definition discrete_le x y := (x = y).

  Lemma discrete_le_refl : reflexive discrete_le.
  Proof. by []. Qed.

  Lemma discrete_le_trans : transitive discrete_le.
  Proof. by move=> x y z ->. Qed.

  Canonical discrete_proMixin := ProMixin discrete_le_refl discrete_le_trans.
  Canonical discrete_proType := Eval hnf in ProType discrete discrete_proMixin.

  Lemma discrete_le_eq : antisymmetric discrete_le.
  Proof. by move=> x y ->. Qed.

  Canonical discrete_ordMixin := OrdMixin discrete_le_eq.
  Canonical discrete_ordType := Eval hnf in OrdType discrete discrete_ordMixin.
End DiscreteOrder.

Notation "'Δ' A" := (discrete A) (at level 2).
